
/*
 * Vis5D system for visualizing five dimensional gridded data sets.
 * Copyright (C) 1990 - 2000 Bill Hibbard, Johan Kellum, Brian Paul,
 * Dave Santek, and Andre Battaiola.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * As a special exception to the terms of the GNU General Public
 * License, you are permitted to link Vis5D with (and distribute the
 * resulting source and executables) the LUI library (copyright by
 * Stellar Computer Inc. and licensed for distribution with Vis5D),
 * the McIDAS library, and/or the NetCDF library, where those
 * libraries are governed by the terms of their own licenses.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "../config.h"

netcdf2julian(record, sdate, stime, tstep, year, day, hour, min, sec)
int record;			/* record number from the data file */
int sdate;			/* Julian start date for record #1 */
int stime;			/* Julian start time for record #1 */
int tstep;			/* time step increment for each record */
int *year;
int *day;
int *hour;
int *min;
int *sec;
{

int time;

*year = sdate/1000;			/* extract year from Julian date */
*day = sdate - (*year * 1000);		/* extract day of year from Julian */

time = stime + (record - 1) * tstep;	/* get time of current record */ 

*hour = time/10000;
*min = (time - (*hour * 10000))/100;
*sec = time - (*hour * 10000) - (*min * 100);
}

